
#ifdef _MSVC
typedef __int64 sll;
#define SLL(x) x##I64
#define SLL_FMT "%i64"
#else
#if SIZOF_LONG == 8
typedef long sll;
#define SLL(x) x##L
#define SLL_FMT "%ld"
#else
typedef long long sll;
#define SLL(x) x##LL
#define SLL_FMT "%lld"
#endif
#endif

typedef enum {
	DURATION_PRECISION_Y = 4,
	DURATION_PRECISION_M = 6,
	DURATION_PRECISION_D = 8,
	DURATION_PRECISION_H = 10,
	DURATION_PRECISION_I = 12,
	DURATION_PRECISION_S = 14
} duration_precision_t;

struct tm *sll2tm(struct tm *t, sll date);

sll duration(struct tm *t1, struct tm *t2, duration_precision_t w);
sll duration_y(struct tm *t1, struct tm *t2);
sll duration_m(struct tm *t1, struct tm *t2);
sll duration_d(struct tm *t1, struct tm *t2);
sll duration_h(struct tm *t1, struct tm *t2);
sll duration_i(struct tm *t1, struct tm *t2);
sll duration_s(struct tm *t1, struct tm *t2);
